<template>
    <nav class="navbar navbar-expand-lg navbar-light border-bottom">
        <div class="container-fluid d-flex justify-content-between">
            <ul class="navbar-nav me-auto mb-2 mb-lg-0  space">
                <tool-list
                    v-for="(item, index) in toolBar"
                    :key="index"
                    :item="item" 
                    @click="checkAction(item.action)"
                />
            </ul>    
        </div>
    </nav>
    <div class="table-responsive">
        <table class="table">
            <thead>
                <tr class="text-light bg-primary border-0 text-center">
                    <th class="px-1 mx-1" style="width:3%;"></th>
                    <th-element
                        v-for="(item, index) in inputItems"
                        :key="index"
                        :item="item"
                        @click="(inVisible = !inVisible)"
                    />
                </tr>
            </thead>
        
            <tbody >
                <input-table
                @cleanInput="clearInputValue"
                :items="inputItems" v-if="inVisible" 
                />
                <list-data-table 
                v-for="(item, index) in searchElement"
                :key="index" 
                :item="item" 
                :inputItems="inputItems"
                :contextItem="contextItem"
                @editDblclic="editDblclic" 
                @IS_CHECKED="isChecked"
                />
            </tbody>
        </table>
    </div>
    <router-view></router-view>
    <footer-pages 
        :pageNumber="pageNumber" 
        :limitPage="limitPage" 
        :count="count"
        @nextPage="nextPage" 
        @prevPage="prevPage"
    />
</template>

<script>
import ListDataTable from '@/components/UI/ListDataTable.vue';
import ThElement from '@/components/UI/ThElement.vue';
import {ref, onMounted, computed, watchEffect} from 'vue';
import { useStore } from 'vuex';
import {useRouter, useRoute } from 'vue-router';

export default {
    components: { ListDataTable, ThElement },
    setup(_, {emit}){
        const store = useStore();
        const router = useRouter()
        const route = useRoute()
        const inVisible = ref(false);
        const pageNumber = ref(0);
        const limitPage = ref(8);

        const contextItem = ref([
            {name:'inn', desc:'Скопировать ИНН', action: 'copyElem'},
            {name:'name', desc:'Скопировать наименование', action: 'copyElem'},
            {name:'f_address', desc:'Скопировать фактический адрес', action: 'copyElem'},
            {name:'email', desc:'Скопировать эл. почту', action: 'copyElem'},

        ])
        
        onMounted(()=> { store.dispatch('GET_LIST_ITEMS_FROM_API');});

        const inputItems = computed(() => store.getters.CLIENT_INPUT_ITEMS);

        const listItems = computed(() => store.getters.LIST_ITEMS);
        
        const count = computed(() => store.getters.LIST_ITEMS_COUNT)

        const toolBar = computed(() => store.getters.CLIENTS_TOOL_BAR);

        function updateListItems(data){store.commit('SET_LIST_ITEM_TO_STATE', data)};

        const searchElement = computed(() => {
        
            let name = '';
            let value = '';

            inputItems.value.forEach(el => {
                if(el.value){
                    name = el.name;
                    value = el.value;
                }
            });
            
            if(!inputItems.value.some(elem => elem[name])){
                return paginatedData();
            } else {
                return paginatedData().filter(item => item[name].toLowerCase().includes(value.toLowerCase()));
            }
        
        });

        watchEffect(() => checkInVisible());
        
        function checkInVisible(){
            if(!inVisible.value){
                clearInputValue();  
            }
        }    
        
        function checkAction(action){
            inVisible.value = false;
            switch (action) {
                case 'delete':
                    deleteItemById();
                    break;
                case 'edit':
                    edit();
                    break;
            }
        }
        
        function nextPage(){
            pageNumber.value++;
        }

        function prevPage(){
            pageNumber.value--;
        }
        
        function paginatedData(){
            let start = pageNumber.value * limitPage.value,
            end = start + limitPage.value;
            return listItems.value.slice(start, end); 
        }

        function clearInputValue(){
            inputItems.value.forEach(el => el.value = '');
        }

        function editDblclic(id){
            inVisible.value = false;
            router.push('/clients/edit/' + id)
        }

        function isChecked(id){
            
            store.commit('IS_CHECKED_CHANGE_LIST_ITEM_TO_STAGE', id)
        }

        function edit(){
            const count =  listItems.value.filter(item => item.isChecked === true).length
            if(count === 1) {
                    const id = listItems.value.find(el => el.isChecked === true).id
                    router.push('/clients/edit/' + id)
            }else if(count > 1){
                    alert('Выберите только один элемент!')
            }else {
                    alert('Выберите хотя бы один элемент!')
            }
        }

        function deleteItemById(){
            if(listItems.value.filter(item => item.isChecked === true).length < 1){
                alert('Элементы для удаления не выбраны!')
            }else{
                if(confirm('Вы действительно хотите удалить выбранные Вами элементы ?')){
                    listItems.value.forEach(el => {
                        if(el.isChecked){
                            updateListItems(listItems.value.filter(p => p.id !== el.id)); 
                        }
                    });
                }
            }    
        }

        return {
            toolBar,
            inputItems,
            inVisible,
            pageNumber,
            searchElement,
            count,
            contextItem,
            pageNumber,
            limitPage,
            isChecked,
            checkAction,
            nextPage,
            prevPage,
            clearInputValue,
            editDblclic
        }
    }
    // data(){
    //     return {
    //         inVisible: false,
    //         tools: [],
    //         inputItems: [],
    //         listItems: [],
    //         totalPage: 0,
    //         limitPage: 3,
    //         page: 1,
    //         elementCount: 0,
    //         pageNumber: 0,        
    //     }
    // },
    // watch: {
    //     inVisible(){
    //         if(!this.inVisible){
    //             this.clearInputValue();  
    //         }
    //     },
    // },    
    // computed: {
    //     ...mapGetters([
    //         'LIST_ITEMS'
    //     ]),
       
    //     searchElement(){
    //         let name = '';
    //         let value = '';

    //        this.inputItems.forEach(el => {
    //             if(el.value){
    //                 name = el.name;
    //                 value = el.value;
    //             }
    //        })
           
    //        if(!this.LIST_ITEMS.some(elem => elem[name])){
    //         return this.paginatedData
    //        } 

    //        return this.paginatedData.filter(item => item[name].toLowerCase().includes(value.toLowerCase()));
    //     },
    //     pageCount(){
    //         let l = this.LIST_ITEMS.length,
    //         s = this.limitPage;
    //         return Math.ceil(l/s);
    //     },
    //     paginatedData(){
    //         const start = this.pageNumber * this.limitPage,
    //         end = start + this.limitPage;
    //         return this.LIST_ITEMS.slice(start, end);
    //     },
    // },        
    // mounted(){
    //     this.GET_LIST_ITEMS_FROM_API();
        
    //     this.inputItems = this.$store.state.entryData.inputItems;
    //     this.tools = this.$store.state.panelTools.clientsToolsBar; 
    // },
    // methods: {
    //     ...mapActions([
    //         'GET_LIST_ITEMS_FROM_API'
    //     ]),
    //     ... mapMutations([
    //         'SET_LIST_ITEM_TO_STATE',            
    //     ]),
    //     clearInputValue(){
    //         this.inputItems.forEach(el => el.value = '');
    //     },
    //     checkAction(action){
    //         this.inVisible = false;
    //         switch (action) {
    //             case 'delete':
    //                 this.delete();
    //                 break;
    //             case 'edit':
    //                 this.edit();
    //                 break;
    //         }
    //     },
    //     edit(){
    //        const count =  this.listItems.filter(item => item.isChecked === true).length
        
    //         if(count === 1) {
    //                 const id = this.listItems.find(el => el.isChecked === true).id
    //                 this.$router.push('/clients/edit/' + id)
    //         }else if(count > 1){
    //                 alert('Выберите только один элемент!')
    //         }else {
    //                 alert('Выберите хотя бы один элемент!')
    //         }
    //     },
    //     editDblclic(id){
    //         this.inVisible = false;
    //         this.$router.push('/clients/edit/' + id)
    //     },
    //     changePage(pageNum) {
    //         this.page = pageNum;
    //     },
    //     count(){
    //         this.elementCount = this.listItems.length;
    //     },
    //     nextPage(){
    //         this.pageNumber++;
    //     },
    //     prevPage(){
    //         this.pageNumber--;
    //     },
    //     delete(){
    //         if(this.listItems.filter(item => item.isChecked === true).length < 1){
    //             alert('Элементы для удаления не выбраны!')
    //         }else{
    //             if(confirm('Вы действительно хотите удалить выбранные Вами элементы ?')){
    //                 this.listItems.forEach(el => {
    //                     if(el.isChecked){
                        
    //                         this.listItems = this.listItems.filter(p => p.id !== el.id);  
    //                         this.$store.state.entryData.listItems = this.listItems;
    //                     }
    //                 })
    //             }
    //         }    
    //     },
    // }
    
}
</script>

<style>

</style>
